<?php

/** 
*
* install script to set up permission options in the db for foo mod
* @license http://opensource.org/licenses/gpl-license.php GNU Public License 
*
*/

/**
* @ignore
*/

//update configuration
define('V1_ADMS_GROUP', 5);
define('V1_MODS_GROUP', 4);

// initialize the page
define('IN_PHPBB', true);
define('IN_INSTALL', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);

$user->session_begin();
$auth->acl($user->data);

// Install v2.0.0 SQL Queries
	$sql = 'ALTER TABLE '.GROUPS_TABLE.' ADD group_bgcolour VARCHAR(6) NOT NULL';
	$result = $db->sql_query($sql);
	$db->sql_freeresult($result);

	$sql = 'ALTER TABLE '.POSTS_TABLE.' ADD post_as_groupmember MEDIUMINT(8) NOT NULL DEFAULT \'0\'';
	$result = $db->sql_query($sql);
	$db->sql_freeresult($result);

//v2.0.0 : configure group's background color
	$sql = 'UPDATE '.GROUPS_TABLE.' SET group_bgcolour = (SELECT config_value FROM '.CONFIG_TABLE.' WHERE config_name = \'cbgm_admin_color\') WHERE group_id = '.V1_ADMS_GROUP;
	$result = $db->sql_query($sql);
	$db->sql_freeresult($result);

	$sql = 'UPDATE '.GROUPS_TABLE.' SET group_bgcolour = (SELECT config_value FROM '.CONFIG_TABLE.' WHERE config_name = \'cbgm_mod_color\') WHERE group_id = '.V1_MODS_GROUP;
	$result = $db->sql_query($sql);
	$db->sql_freeresult($result);
	
//v2.0.0 : convert posts's background color from v1.0.x
	//Select all post affected by v1.0.x
	$sql = 'SELECT post_id, poster_id 
			FROM '.POSTS_TABLE.' 
			WHERE enable_cbgm = 1';
	$result = $db->sql_query($sql);

	//Convert
	$admin_arr = array();
	while ($row = $db->sql_fetchrow($result))
	{
		//We need to determine if the message was posted as an administrator. If not, it was as an moderator.
		if(!isset($admin_arr[$row['poster_id']]))
		{
			//Verify if user is admin
			if(sizeof($auth->acl_raw_data($row['poster_id'],"a_")) > 0)
			{
				$admin_arr[$row['poster_id']] = true;
			}
			else
			{
				$admin_arr[$row['poster_id']] = false; //means that user is a moderator because we only get messages posted as admins or mods...
			}
		}
		
		//Converting...
		$sql_update = '';
		if($admin_arr[$row['poster_id']])
		{
			$sql_update = V1_ADMS_GROUP;
		}
		else
		{
			$sql_update = V1_MODS_GROUP;
		}
		
		$sql2 = 'UPDATE '.POSTS_TABLE.' SET post_as_groupmember = '.$sql_update.' WHERE post_id = '.$row['post_id'];
		$result2 = $db->sql_query($sql2);
		$db->sql_freeresult($result2);		
	}
	
	$db->sql_freeresult($result);
	
//v2.0.0 : Delete v1.0.0 sql queries
	$sql = 'DELETE FROM '.CONFIG_TABLE.' WHERE config_name = \'load_cbgm_default\'';
	$result = $db->sql_query($sql);
	$db->sql_freeresult($result);
	
	$sql = 'DELETE FROM '.CONFIG_TABLE.' WHERE config_name = \'load_cbgm_admin\'';
	$result = $db->sql_query($sql);
	$db->sql_freeresult($result);

	$sql = 'DELETE FROM '.CONFIG_TABLE.' WHERE config_name = \'cbgm_admin_color\'';
	$result = $db->sql_query($sql);
	$db->sql_freeresult($result);

	$sql = 'DELETE FROM '.CONFIG_TABLE.' WHERE config_name = \'load_cbgm_mod\'';
	$result = $db->sql_query($sql);
	$db->sql_freeresult($result);
	
	$sql = 'DELETE FROM '.CONFIG_TABLE.' WHERE config_name = \'cbgm_mod_color\'';
	$result = $db->sql_query($sql);
	$db->sql_freeresult($result);

	$sql = 'ALTER TABLE '.POSTS_TABLE.' DROP enable_cbgm';
	$result = $db->sql_query($sql);
	$db->sql_freeresult($result);	

//Done
$message = 'MOD updated to v2.0.x<br /><br />';
$message .= 'Please delete this file.<br />';
$message .= 'Merci de supprimer ce fichier.<br />';
trigger_error($message);

?>